--[[
	SignaInferreSK.lua
		Signa Inferre Suicide Kings
--]]

local SignaInferreSK = LibStub("AceAddon-3.0"):NewAddon("SignaInferreSK", "AceConsole-3.0", "AceHook-3.0", "AceComm-3.0", "AceSerializer-3.0", "AceEvent-3.0")

SignaInferreSK.bg = {
	bgFile = 'Interface\\DialogFrame\\UI-DialogBox-Background',
	edgeFile = 'Interface\\DialogFrame\\UI-DialogBox-Border',
	insets = {left = 11, right = 11, top = 12, bottom = 11},
	tile = true,
	tileSize = 32,
	edgeSize = 32,
}

local AddonEnabled = false;
local Master = false;
local BidNotOpen = true;
local ItemLink = nil
local HighRank = 5000
local HighName = ""
local BidsReceived = 0
local BidList = {}
local RollList = {}
local RollCount = 0
local HighRoller = "" 
local HighRoll = 0
local EntrySelected = nil
local MyBidType = ""
local BidType = ""
local Timer = 19
local BidTicker = nil
local RollTicker = nil

local TokenNames = {
	["Chestguard of the Fallen Defender"] = true,
	["Chestguard of the Fallen Hero"] = true,
	["Chestguard of the Fallen Champion"] = true,
	["Leggings of the Fallen Defender"] = true,
	["Leggings of the Fallen Hero"] = true,
	["Leggings of the Fallen Champion"] = true,
	["Helm of the Fallen Defender"] = true,
	["Helm of the Fallen Hero"] = true,
	["Helm of the Fallen Champion"] = true,
	["Gloves of the Fallen Defender"] = true,
	["Gloves of the Fallen Hero"] = true,
	["Gloves of the Fallen Champion"] = true,
	["Pauldrons of the Fallen Defender"] = true,
	["Pauldrons of the Fallen Hero"] = true,
	["Pauldrons of the Fallen Champion"] = true,
	["Chestguard of the Vanquished Defender"] = true,
	["Chestguard of the Vanquished Hero"] = true,
	["Chestguard of the Vanquished Champion"] = true,
	["Leggings of the Vanquished Defender"] = true,
	["Leggings of the Vanquished Hero"] = true,
	["Leggings of the Vanquished Champion"] = true,
	["Helm of the Vanquished Defender"] = true,
	["Helm of the Vanquished Hero"] = true,
	["Helm of the Vanquished Champion"] = true,
	["Gloves of the Vanquished Defender"] = true,
	["Gloves of the Vanquished Hero"] = true,
	["Gloves of the Vanquished Champion"] = true,
	["Pauldrons of the Vanquished Defender"] = true,
	["Pauldrons of the Vanquished Hero"] = true,
	["Pauldrons of the Vanquished Champion"] = true
}

local function GiveLoot(itemLink, lootReciever)
	local itemDrops = GetNumLootItems() or 0
	if itemDrops < 1 or itemDrops == nil then
		return
	end

	for iterSlot = 1, itemDrops do
		local slotLink = GetLootSlotLink(iterSlot)

		if slotLink == itemLink then
			for index = 1, math.max(GetNumSubgroupMembers() + 1, GetNumGroupMembers()) do
				local candidate = GetMasterLootCandidate(iterSlot, index)

				if not candidate then
					break
				end

				if candidate == lootReciever then
					GiveMasterLoot(iterSlot, index)
					return
				end
			end
		end
	end
end

local function IconEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	GameTooltip:SetHyperlink(ItemLink);
	GameTooltip:Show();
	CursorUpdate(self);
end

local function IconLeave()
	GameTooltip:Hide();
	ResetCursor();
end

local function IconUpdate(self)
	if ( GameTooltip:IsOwned(self) ) then
		IconEnter(self);
	end
	CursorOnUpdate(self);
end

local function IconClick(self)
	if ( IsModifiedClick() ) then
		HandleModifiedItemClick(ItemLink);
	end
end

local function OpenListEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("BOTTOMLEFT", self, "TOPRIGHT")
	GameTooltip:SetText("View Lists")
	GameTooltip:Show()
end

local function OpenListLeave()
	GameTooltip:Hide()
end

local function Suicide(entry, list)
	local suicider = entry;
	local current = entry + 1;

	if(list == "nList") then
		if (current < SignaInferreSK.db.char.nLength) then
			for i=current, SignaInferreSK.db.char.nLength, 1 do
				if (UnitPlayerOrPetInRaid(SignaInferreSK.db.char.nList[i].name) == true) then
					local temp = SignaInferreSK.db.char.nList[i];
					SignaInferreSK.db.char.nList[i] = SignaInferreSK.db.char.nList[suicider];
					SignaInferreSK.db.char.nList[suicider] = temp;
					suicider = i;
				end
			end
			SignaInferreSK.db.char.nStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.nStamp);
		end
	else
		if (current < SignaInferreSK.db.char.tLength) then
			for i=current, SignaInferreSK.db.char.tLength, 1 do
				if (UnitPlayerOrPetInRaid(SignaInferreSK.db.char.tList[i].name) == true) then
					local temp = SignaInferreSK.db.char.tList[i];
					SignaInferreSK.db.char.tList[i] = SignaInferreSK.db.char.tList[suicider];
					SignaInferreSK.db.char.tList[suicider] = temp;
					suicider = i;
				end
			end
			SignaInferreSK.db.char.tStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.tStamp);
		end
	end

	SISKListFrame.selectedEntry = suicider;
end

local function ScrollList_Update()
	local entryOffset = FauxScrollFrame_GetOffset(SISKListFrame.list);

	for i=1, 17, 1 do
		local entryIndex = entryOffset + i;
		if ( entryIndex == SISKListFrame.selectedEntry ) then
			SISKListFrame["entry" .. i]:LockHighlight();
			SISKListFrame.down:SetPoint('RIGHT', SISKListFrame["entry" .. i], 'RIGHT', -2, 0);
			SISKListFrame.down:Show();
			SISKListFrame.up:Show();
		else
			SISKListFrame["entry" .. i]:UnlockHighlight();
		end
	end

	if (SISKListFrame.selectedEntry > entryOffset+17) or (SISKListFrame.selectedEntry <= entryOffset) then
		SISKListFrame.down:Hide();
		SISKListFrame.up:Hide();
	end

	if(PanelTemplates_GetSelectedTab(SISKListFrame) == 1) then
		local line;
		local lineplusoffset;

		for line=1,17 do
			lineplusoffset = line + FauxScrollFrame_GetOffset(SISKListFrame.list);
			if lineplusoffset <= SignaInferreSK.db.char.nLength then
				if SignaInferreSK.db.char.nList[lineplusoffset].bid == "" then
					SISKListFrame["entry" .. line].text:SetText(lineplusoffset..". "..SignaInferreSK.db.char.nList[lineplusoffset].name);
				else
					SISKListFrame["entry" .. line].text:SetText(lineplusoffset..". "..SignaInferreSK.db.char.nList[lineplusoffset].name.." - "..SignaInferreSK.db.char.nList[lineplusoffset].bid);
				end
				local color = RAID_CLASS_COLORS[SignaInferreSK.db.char.nList[lineplusoffset].class];
				if (UnitPlayerOrPetInRaid(SignaInferreSK.db.char.nList[lineplusoffset].name) == true) then
					SISKListFrame["entry" .. line].text:SetTextColor(color.r, color.g, color.b);
				else
					SISKListFrame["entry" .. line].text:SetTextColor(0.5, 0.5, 0.5);
				end
				SISKListFrame["entry" .. line].text:Show();
			else
				SISKListFrame["entry" .. line].text:Hide();
			end
		end

		if(SISKListFrame.selectedEntry == 1) and Master then
			SISKListFrame.up:Disable();
		elseif Master then
			SISKListFrame.up:Enable();
		end

		if(SISKListFrame.selectedEntry == SignaInferreSK.db.char.nLength) and Master then
			SISKListFrame.down:Disable();
		elseif Master then
			SISKListFrame.down:Enable();
		end

		if(SISKListFrame.selectedEntry > SignaInferreSK.db.char.nLength) and Master then
			SISKListFrame.down:Disable();
			SISKListFrame.up:Disable();
		end

		FauxScrollFrame_Update(SISKListFrame.list,SignaInferreSK.db.char.nLength,17,16);
	elseif(PanelTemplates_GetSelectedTab(SISKListFrame) == 2) then
		local line;
		local lineplusoffset;

		for line=1,17 do
			lineplusoffset = line + FauxScrollFrame_GetOffset(SISKListFrame.list);
			if lineplusoffset <= SignaInferreSK.db.char.tLength then
				if SignaInferreSK.db.char.tList[lineplusoffset].bid == "" then
					SISKListFrame["entry" .. line].text:SetText(lineplusoffset..". "..SignaInferreSK.db.char.tList[lineplusoffset].name);
				else
					SISKListFrame["entry" .. line].text:SetText(lineplusoffset..". "..SignaInferreSK.db.char.tList[lineplusoffset].name.." - "..SignaInferreSK.db.char.tList[lineplusoffset].bid);
				end
				local color = RAID_CLASS_COLORS[SignaInferreSK.db.char.tList[lineplusoffset].class];
				if (UnitPlayerOrPetInRaid(SignaInferreSK.db.char.tList[lineplusoffset].name) == true) then
					SISKListFrame["entry" .. line].text:SetTextColor(color.r, color.g, color.b);
				else
					SISKListFrame["entry" .. line].text:SetTextColor(0.5, 0.5, 0.5);
				end
				SISKListFrame["entry" .. line].text:Show();
			else
				SISKListFrame["entry" .. line].text:Hide();
			end
		end

		if(SISKListFrame.selectedEntry == 1) and Master then
			SISKListFrame.up:Disable();
		elseif Master then
			SISKListFrame.up:Enable();
		end

		if(SISKListFrame.selectedEntry == SignaInferreSK.db.char.tLength) and Master then
			SISKListFrame.down:Disable();
		elseif Master then
			SISKListFrame.down:Enable();
		end

		if(SISKListFrame.selectedEntry > SignaInferreSK.db.char.tLength) and Master then
			SISKListFrame.down:Disable();
			SISKListFrame.up:Disable();
		end

		FauxScrollFrame_Update(SISKListFrame.list,SignaInferreSK.db.char.tLength,17,16);
	end
end

local function ClickTTab()
	PlaySound(SOUNDKIT.IG_CHARACTER_INFO_TAB)
	PanelTemplates_SetTab(SISKListFrame, 2);
	SISKListFrame.title:SetText("Token List");
	SISKListFrame.selectedEntry = 0;
	SISKListFrame.add:Show();
	SISKListFrame.del:Show();
	SISKListFrame.up:Show();
	SISKListFrame.down:Show();
	SISKListFrame.murder:Show();
	SISKListFrame.closeBid:Show();
	SISKListFrame.sync:Show();
	SISKListFrame.list:Show();

	for i = 1, 17 do
		SISKListFrame["entry" .. i]:Show()
	end

	SISKListFrame.enableCheck:Hide();
	SISKListFrame.import:Hide();
	SISKListFrame.export:Hide();
	SISKListFrame.tokenRadio:Hide();
	SISKListFrame.normalRadio:Hide();
	SISKListFrame.exportHistory:Hide();
	SISKListFrame.clearHistory:Hide();
	SISKListFrame.versionText:Hide();
	SISKListFrame.editScroll:Hide()
	ScrollList_Update();
end

local function ClickNTab()
	PlaySound(SOUNDKIT.IG_CHARACTER_INFO_TAB)
	PanelTemplates_SetTab(SISKListFrame, 1);
	SISKListFrame.title:SetText("Generic List");
	SISKListFrame.selectedEntry = 0;
	SISKListFrame.add:Show();
	SISKListFrame.del:Show();
	SISKListFrame.up:Show();
	SISKListFrame.down:Show();
	SISKListFrame.murder:Show();
	SISKListFrame.closeBid:Show();
	SISKListFrame.sync:Show();
	SISKListFrame.list:Show();

	for i = 1, 17 do
		SISKListFrame["entry" .. i]:Show()
	end

	SISKListFrame.enableCheck:Hide();
	SISKListFrame.import:Hide();
	SISKListFrame.export:Hide();
	SISKListFrame.tokenRadio:Hide();
	SISKListFrame.normalRadio:Hide();
	SISKListFrame.exportHistory:Hide();
	SISKListFrame.clearHistory:Hide();
	SISKListFrame.versionText:Hide();
	SISKListFrame.editScroll:Hide()
	ScrollList_Update();
end

local function ClickITab()
	PlaySound(SOUNDKIT.IG_CHARACTER_INFO_TAB)
	PanelTemplates_SetTab(SISKListFrame, 3);
	SISKListFrame.title:SetText("Import/Export Lists");
	SISKListFrame.add:Hide();
	SISKListFrame.del:Hide();
	SISKListFrame.up:Hide();
	SISKListFrame.down:Hide();
	SISKListFrame.murder:Hide();
	SISKListFrame.closeBid:Hide();
	SISKListFrame.sync:Hide();
	SISKListFrame.list:Hide();

	for i = 1, 17 do
		SISKListFrame["entry" .. i]:Hide()
	end

	if(Master) then
		SISKListFrame.enableCheck:Show();
		SISKListFrame.enableCheck:SetChecked(AddonEnabled);
	end

	SISKListFrame.import:Show();
	SISKListFrame.export:Show();
	SISKListFrame.tokenRadio:Show();
	SISKListFrame.normalRadio:Show();
	SISKListFrame.exportHistory:Show();
	SISKListFrame.clearHistory:Show();
	SISKListFrame.versionText:Show();
	SISKListFrame.editScroll:Show()
end

local function OpenListClick()
	ScrollList_Update()
	SISKListFrame:Show()
end

local function EntrySelect(self)
	SISKListFrame.selectedEntry = FauxScrollFrame_GetOffset(SISKListFrame.list) + self:GetID()
	ScrollList_Update()
end

local function EntryClick(self, button, down)
	EntrySelect(self);
end

local function EnableClick(self, button, down)
	AddonEnabled = SISKListFrame.enableCheck:GetChecked();
end

local function AddClick(self, button, down)
	if(PanelTemplates_GetSelectedTab(SISKListFrame) == 1) then
		if (UnitExists("target") == true) and (UnitIsPlayer("target") == true) then
			if (SignaInferreSK.db.char.nLength == nil) then
				SignaInferreSK.db.char.nLength = 0;
			end
			if (SignaInferreSK.db.char.nList == nil) then
				SignaInferreSK.db.char.nList = {};
			end

			SignaInferreSK.db.char.nLength = SignaInferreSK.db.char.nLength + 1;

			local _, englishClass = UnitClass("target");
			SignaInferreSK.db.char.nList[SignaInferreSK.db.char.nLength] = {name = UnitName("target"), class = englishClass, bid = ""};
			SignaInferreSK.db.char.nStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.nStamp);

		end
	elseif(PanelTemplates_GetSelectedTab(SISKListFrame) == 2) then
		if (UnitExists("target") == true) and (UnitIsPlayer("target") == true) then
			if (SignaInferreSK.db.char.tLength == nil) then
				SignaInferreSK.db.char.tLength = 0;
			end
			if (SignaInferreSK.db.char.tList == nil) then
				SignaInferreSK.db.char.tList = {};
			end

			SignaInferreSK.db.char.tLength = SignaInferreSK.db.char.tLength + 1;

			local _, englishClass = UnitClass("target");
			SignaInferreSK.db.char.tList[SignaInferreSK.db.char.tLength] = {name = UnitName("target"), class = englishClass, bid = ""};
			SignaInferreSK.db.char.tStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.tStamp);

		end
	end

	SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	ScrollList_Update();
end

local function UpClick(self, button, down)
	if(PanelTemplates_GetSelectedTab(SISKListFrame) == 1) then
		local temp = SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry];
		SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry] = SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry-1];
		SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry-1] = temp;
		SISKListFrame.selectedEntry = SISKListFrame.selectedEntry-1;
		SignaInferreSK.db.char.nStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.nStamp);
	elseif(PanelTemplates_GetSelectedTab(SISKListFrame) == 2) then
		local temp = SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry];
		SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry] = SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry-1];
		SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry-1] = temp;
		SISKListFrame.selectedEntry = SISKListFrame.selectedEntry-1;
		SignaInferreSK.db.char.tStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.tStamp);
	end

	SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	ScrollList_Update();
end

local function DownClick(self, button, down)
	if(PanelTemplates_GetSelectedTab(SISKListFrame) == 1) then
		local temp = SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry];
		SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry] = SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry+1];
		SignaInferreSK.db.char.nList[SISKListFrame.selectedEntry+1] = temp;
		SISKListFrame.selectedEntry = SISKListFrame.selectedEntry+1;
		SignaInferreSK.db.char.nStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.nStamp);
	elseif(PanelTemplates_GetSelectedTab(SISKListFrame) == 2) then
		local temp = SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry];
		SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry] = SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry+1];
		SignaInferreSK.db.char.tList[SISKListFrame.selectedEntry+1] = temp;
		SISKListFrame.selectedEntry = SISKListFrame.selectedEntry+1;
		SignaInferreSK.db.char.tStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.tStamp);
	end

	SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	ScrollList_Update();
end

local function DeleteClick(self, button, down)
	if(SISKListFrame.selectedEntry ~= 0) then
		if(PanelTemplates_GetSelectedTab(SISKListFrame) == 1) then
			if(SignaInferreSK.db.char.nLength >= SISKListFrame.selectedEntry) then
				table.remove(SignaInferreSK.db.char.nList, SISKListFrame.selectedEntry)
				SignaInferreSK.db.char.nLength = SignaInferreSK.db.char.nLength - 1;
				SignaInferreSK.db.char.nStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.nStamp);
			end
		elseif(PanelTemplates_GetSelectedTab(SISKListFrame) == 2) then
			if(SignaInferreSK.db.char.tLength >= SISKListFrame.selectedEntry) then
				table.remove(SignaInferreSK.db.char.tList, SISKListFrame.selectedEntry)
				SignaInferreSK.db.char.tLength = SignaInferreSK.db.char.tLength - 1;
				SignaInferreSK.db.char.tStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.tStamp);
			end
		end

		SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
		ScrollList_Update();
	end 
end

local function CloseBidClick(self, button, down)
	if (HighName ~= "") then
		SISKConfirmGiveLootFrame.title:SetText(string.format("%s win the loot.\nAre you sure?", HighName))
		SISKConfirmGiveLootFrame:Show();
	elseif (HighRoller ~= "") then
		SISKConfirmGiveLootFrame.title:SetText(string.format("%s win the loot.\nAre you sure?", HighRoller))
		SISKConfirmGiveLootFrame:Show();
	else
		SignaInferreSK:ResetBidInformation();
	end
end

function SignaInferreSK:ResetBidInformation()
	if (BidType == "bid" and not BidTicker:IsCancelled()) then
		SendChatMessage("Bid closed!", "RAID_WARNING");
		BidTicker:Cancel();
	end
	if (BidType == "roll" and not RollTicker:IsCancelled()) then
		SendChatMessage("Roll closed!", "RAID_WARNING");
		RollTicker:Cancel();
	end

	HighRank = 5000;
	HighName = "";
	BidsReceived = 0;
	ItemLink = nil;
	BidList = {};
	RollList = {};
	RollCount = 0;
	HighRoller = ""; 
	HighRoll = 0;
	BidNotOpen = true;
	Timer = 19;
	BidTicker = nil;
	RollTicker = nil;

	SignaInferreSK:SendCommMessage("SISKCloseBid", "cb", "RAID");

	SISKListFrame.closeBid:Disable();

	ScrollList_Update();
end

local function MurderClick(self, button, down)
	local list;
	if (SISKListFrame.selectedEntry ~= 0) then
		if(PanelTemplates_GetSelectedTab(SISKListFrame) == 1) then
			list = "nList";
		elseif(PanelTemplates_GetSelectedTab(SISKListFrame) == 2) then
			list = "tList";
		end
		Suicide(SISKListFrame.selectedEntry, list);
		SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
		ScrollList_Update();
	end 
end

local function SyncClick(self, button, down)
	if (Master) then
		SignaInferreSK:SendCommMessage("SISKSyncReq", "master", "RAID");
	else
		SignaInferreSK:SendCommMessage("SISKSyncReq", "not master", "RAID");
	end
end

local function ExportClick(self, button, down)
	local exportList = "";

	if(SISKListFrame.normalRadio:GetChecked() == true) then
		for i=1, SignaInferreSK.db.char.nLength, 1 do
			exportList = exportList..i..". "..SignaInferreSK.db.char.nList[i].name.." "..strlower(SignaInferreSK.db.char.nList[i].class).."\n";
		end

		SISKListFrame.editArea:SetText(exportList);
		SISKListFrame.editArea:HighlightText(0);
	elseif(SISKListFrame.tokenRadio:GetChecked() == true) then
		for i=1, SignaInferreSK.db.char.tLength, 1 do
			exportList = exportList..i..". "..SignaInferreSK.db.char.tList[i].name.." "..strlower(SignaInferreSK.db.char.tList[i].class).."\n";
		end

		SISKListFrame.editArea:SetText(exportList);
		SISKListFrame.editArea:HighlightText(0);
	end
end

local function ImportClick(self, button, down)
	SISKConfirmFrame:Show();
end

local function NormalRadioClick(self, button, down)
	SISKListFrame.tokenRadio:SetChecked(nil);
end

local function TokenRadioClick(self, button, down)
	SISKListFrame.normalRadio:SetChecked(nil);
end

local function ExportHistoryClick(self, button, down)
	local exportList = "";

	if (SignaInferreSK.db.char.hLength ~= nil) then
		for i=1, SignaInferreSK.db.char.hLength, 1 do
			exportList = exportList..SignaInferreSK.db.char.hList[i].name..";"..SignaInferreSK.db.char.hList[i].item..";"..SignaInferreSK.db.char.hList[i].bidType..";"..SignaInferreSK.db.char.hList[i].list..";"..SignaInferreSK.db.char.hList[i].timestamp.."\n";
		end
	end

	SISKListFrame.editArea:SetText(exportList);
	SISKListFrame.editArea:HighlightText(0);
end

local function ClearHistoryClick(self, button, down)
	SISKConfirmClearHistoryFrame:Show();
end

local function BidClick(self, button, down)
	MyBidType = "bid";
	SignaInferreSK:SendCommMessage("SISKSendBid", SignaInferreSK:Serialize(MyBidType, UnitName("player")), "RAID");
	SISKBidFrame.roll:Disable();
	SISKBidFrame.pass:Disable();
	SISKBidFrame.bid:Disable();
	SISKBidFrame.retract:Enable();
end

local function RollClick(self, button, down)
	MyBidType = "roll";
	SignaInferreSK:SendCommMessage("SISKSendBid", SignaInferreSK:Serialize(MyBidType, UnitName("player")), "RAID");
	SISKBidFrame.roll:Disable();
	SISKBidFrame.pass:Disable();
	SISKBidFrame.bid:Disable();
	SISKBidFrame.retract:Enable();
end

local function PassClick(self, button, down)
	SISKConfirmPassFrame:Show();
end

local function RetractClick(self, button, down)
	SignaInferreSK:SendCommMessage("SISKSendRetract", SignaInferreSK:Serialize(MyBidType, UnitName("player")), "RAID");

	if (BidType == "bid") then
		SISKBidFrame.bid:Enable();
	elseif (BidType == "roll") then
		SISKBidFrame.roll:Enable();
	end

	SISKBidFrame.pass:Enable();
	SISKBidFrame.retract:Disable();
end

local function AcceptClick(self, button, down)
	local text = SISKListFrame.editArea:GetText();
	local i = 1;
	local found, e, rank, pname, class, uclass;

	if (SISKListFrame.normalRadio:GetChecked() == true) then
		SignaInferreSK.db.char.nLength = 0;
		SignaInferreSK.db.char.nList = {};
	elseif (SISKListFrame.tokenRadio:GetChecked() == true) then
		SignaInferreSK.db.char.tLength = 0;
		SignaInferreSK.db.char.tList = {};
	end

	text = text:gsub(".", function(c) local b = c:byte() if b > 127 then return "\\" .. b end end)

	while 1 do
		found, e, rank, pname, class = string.find(text, "(%d+)%p%s([\\%d{3}%a]+)%s(%a+)", i);
		if (found == nil) then
			break;
		else
			uclass = strupper(class);

			if ((uclass ~= "SHAMAN") and (uclass ~= "PALADIN") and (uclass ~= "DRUID") and (uclass ~= "WARRIOR") and (uclass ~= "ROGUE") and
			(uclass ~= "DEATHKNIGHT") and (uclass ~= "PRIEST") and (uclass ~= "WARLOCK") and (uclass ~= "MAGE") and (uclass ~= "HUNTER") and
			(uclass ~= "MONK") and (uclass ~= "DEMONHUNTER")) then
				SignaInferreSK:Print("Error: "..class.." is not a valid class!");
				break;
			end

			pname = pname:gsub("\\(%d+)", string.char)

			if (SISKListFrame.normalRadio:GetChecked() == true) then
				SignaInferreSK.db.char.nLength = SignaInferreSK.db.char.nLength + 1;
				SignaInferreSK.db.char.nList[SignaInferreSK.db.char.nLength] = {name = pname, class = uclass, bid = ""};
				SignaInferreSK.db.char.nStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.nStamp);
			elseif (SISKListFrame.tokenRadio:GetChecked() == true) then
				SignaInferreSK.db.char.tLength = SignaInferreSK.db.char.tLength + 1;
				SignaInferreSK.db.char.tList[SignaInferreSK.db.char.tLength] = {name = pname, class = uclass, bid = ""};
				SignaInferreSK.db.char.tStamp = SignaInferreSK:CreateTimeStamp(SignaInferreSK.db.char.tStamp);
			end
		end

		i = e + 1;
	end

	SISKConfirmFrame:Hide();
	SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	ScrollList_Update();
end

local function DeclineClick(self, button, down)
	SISKConfirmFrame:Hide();
end

local function AcceptPassClick(self, button, down)
	MyBidType = "pass";
	SignaInferreSK:SendCommMessage("SISKSendBid", SignaInferreSK:Serialize(MyBidType, UnitName("player")), "RAID");
	SISKBidFrame:Hide();
	SISKBidFrame.roll:Enable();
	SISKBidFrame.pass:Enable();
	SISKBidFrame.bid:Enable();
	SISKBidFrame.retract:Disable();
	SISKBidFrame.text:SetText("<No High Bidder>");
	SISKBidFrame.text:SetTextColor(1, 1, 1);
	SISKConfirmPassFrame:Hide();
end

local function DeclinePassClick(self, button, down)
	SISKConfirmPassFrame:Hide();
end

local function AcceptClearHistoryClick(self, button, down)
	SignaInferreSK.db.char.hLength = 0;
	SignaInferreSK.db.char.hList = {};
	SISKConfirmClearHistoryFrame:Hide();
end

local function DeclineClearHistoryClick(self, button, down)
	SISKConfirmClearHistoryFrame:Hide();
end

local function AcceptGiveLootClick(self, button, down)
	if (HighName ~= "") then
		local list = SignaInferreSK:WhichList();
		SendChatMessage(HighName.." wins "..ItemLink.."!", "RAID");
		SignaInferreSK:SaveHistory(HighName);
		GiveLoot(ItemLink, HighName)
		Suicide(HighRank, list);
		SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	elseif (HighRoller ~= "") then
		SendChatMessage(HighRoller.." wins "..ItemLink.."!", "RAID");
		SignaInferreSK:SaveHistory(HighRoller);
		GiveLoot(ItemLink, HighRoller)
	end

	SignaInferreSK:ResetBidInformation();
	SISKConfirmGiveLootFrame:Hide();
end

local function DeclineGiveLootClick(self, button, down)
	SignaInferreSK:ResetBidInformation();
	SISKConfirmGiveLootFrame:Hide();
end

function SignaInferreSK:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SignaInferreSKDB")

	if (SignaInferreSK.db.char.nLength == nil) then
		SignaInferreSK.db.char.nLength = 0;
	end

	if (SignaInferreSK.db.char.nStamp == nil) then
		SignaInferreSK.db.char.nStamp = 0;
	end

	if (SignaInferreSK.db.char.tLength == nil) then
		SignaInferreSK.db.char.tLength = 0;
	end

	if (SignaInferreSK.db.char.tStamp == nil) then
		SignaInferreSK.db.char.tStamp = 0;
	end

	SignaInferreSK:RegisterChatCommand("sisk", "OpenList")
	SignaInferreSK:RegisterChatCommand("SISK", "OpenList")

	if (SignaInferreSK.db.char.nLength > 0) then
		for i=1, SignaInferreSK.db.char.nLength, 1 do
			SignaInferreSK.db.char.nList[i].bid = "";
		end
	end

	if (SignaInferreSK.db.char.tLength > 0) then
		for i=1, SignaInferreSK.db.char.tLength, 1 do
			SignaInferreSK.db.char.tList[i].bid = "";
		end
	end
end

function SignaInferreSK:OnEnable()
	SignaInferreSK:InitializeFrames();

	SignaInferreSK:SecureHook("HandleModifiedItemClick", "SISK_HandleModifiedItemClick")

	SignaInferreSK:RegisterComm("SISKOpenBid", "OpenBidding")
	SignaInferreSK:RegisterComm("SISKOpenRoll", "OpenRolling")
	SignaInferreSK:RegisterComm("SISKSendBid", "ReceiveBid")
	SignaInferreSK:RegisterComm("SISKNewHigh", "HighBidder")
	SignaInferreSK:RegisterComm("SISKCloseBid", "CloseBid");
	SignaInferreSK:RegisterComm("SISKSendRetract", "RetractBid");
	SignaInferreSK:RegisterComm("SISKSyncReq", "ReceiveSyncReq");
	SignaInferreSK:RegisterComm("SISKBroadcast", "ReceiveBroadcast");
	SignaInferreSK:RegisterComm("SISKSendList", "ReceiveList");

	SignaInferreSK:RegisterEvent("GROUP_ROSTER_UPDATE")
end

function SignaInferreSK:InitializeFrames()
	local f = CreateFrame('Frame', 'SISKBidFrame', UIParent, BackdropTemplateMixin and "BackdropTemplate")
	f:Hide()

	f:SetWidth(350);
	f:SetHeight(150);
	f:SetPoint("CENTER");
	f:SetBackdrop(SignaInferreSK.bg)
	f:EnableMouse(true)
	f:SetToplevel(true)
	f:SetMovable(true)
	f:SetClampedToScreen(true)
	f:SetFrameStrata('DIALOG')
	f:SetScript('OnMouseDown', f.StartMoving)
	f:SetScript('OnMouseUp', f.StopMovingOrSizing)

	fBackground = f:CreateTexture(nil,"BACKGROUND")
	fBackground:SetTexture('Interface\\AddOns\\SignaInferreSK\\textures\\background64x64.tga')
	fBackground:SetPoint('TOPLEFT', 5, -5)

	f.text = f:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	f.text:SetText("<No High Bidder>")
	f.text:SetPoint('TOP', 0, -30)

	f.link = CreateFrame('ScrollingMessageFrame', nil, f)
	f.link:SetWidth(290)
	f.link:SetHeight(14)
	f.link:SetMaxLines(1)
	f.link:SetFontObject("GameFontNormal");
	f.link:EnableMouse(true)
	f.link:SetScript("OnHyperlinkClick", ChatFrame_OnHyperlinkShow)
	f.link:SetFading(false)
	f.link:SetPoint('BOTTOM', 0, 15)
	f.link:SetTextColor(1, 1, 1)

	f.item = CreateFrame('Button', "ItemIcon", f, "ItemButtonTemplate")
	f.item:SetScale(1.2);
	f.item:EnableMouse(true)
	f.item:SetPoint('TOP', 0, -55)
	f.item.hasItem = 1;
	f.item:Show()
	f.item:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	f.item:SetScript("OnEnter", IconEnter);
	f.item:SetScript("OnLeave", IconLeave);
	f.item:SetScript("OnUpdate", IconUpdate);
	f.item:SetScript("OnClick", IconClick);

	f.bid = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.bid:SetText("Bid")
	f.bid:SetPoint('TOPLEFT', 30, -65)
	f.bid:SetScript('OnClick', BidClick)

	f.pass = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.pass:SetText("Pass")
	f.pass:SetPoint('TOPRIGHT', -30, -90)
	f.pass:SetScript('OnClick', PassClick)

	f.roll = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.roll:SetText("Roll")
	f.roll:SetPoint('TOPRIGHT', -30, -65)
	f.roll:SetScript('OnClick', RollClick)

	f.retract = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.retract:SetText("Retract")
	f.retract:SetPoint('TOPLEFT', 30, -90)
	f.retract:SetScript('OnClick', RetractClick)
	f.retract:Disable()

	f.openList = CreateFrame('Button', nil, f, 'UIPanelScrollDownButtonTemplate')
	f.openList:SetPoint('BOTTOMRIGHT', -12, 10)
	f.openList:EnableMouse(true)
	f.openList:SetScript("OnEnter", OpenListEnter)
	f.openList:SetScript("OnLeave", OpenListLeave)
	f.openList:SetScript("OnClick", OpenListClick)

	local p = CreateFrame('Frame', 'SISKConfirmPassFrame', UIParent, BackdropTemplateMixin and "BackdropTemplate");
	p:Hide();

	p:SetWidth(350); 
	p:SetHeight(80);
	p:SetPoint("CENTER");
	p:SetBackdrop(SignaInferreSK.bg)
	p:EnableMouse(true)
	p:SetToplevel(true)
	p:SetMovable(true)
	p:SetClampedToScreen(true)
	p:SetFrameStrata('DIALOG')
	p:SetScript('OnMouseDown', p.StartMoving)
	p:SetScript('OnMouseUp', p.StopMovingOrSizing)

	p.title = p:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	p.title:SetText("This will close the bid window.\nAre you sure?")
	p.title:SetPoint('TOP', 0, -15)

	p.accept = CreateFrame('Button', 'AcceptPassButton', p, "OptionsButtonTemplate")
	p.accept:SetText("Accept")
	p.accept:SetPoint('BOTTOMLEFT', 35, 15)
	p.accept:SetScript('OnClick', AcceptPassClick)

	p.decline = CreateFrame('Button', nil, p, "OptionsButtonTemplate")
	p.decline:SetText("Decline")
	p.decline:SetPoint('BOTTOMRIGHT', -35, 15)
	p.decline:SetScript('OnClick', DeclinePassClick)

	local l = CreateFrame('Frame', 'SISKListFrame', UIParent, BackdropTemplateMixin and "BackdropTemplate")
	l:Hide()

	l:SetWidth(250); 
	l:SetHeight(400);
	l:SetPoint("CENTER");
	l:SetBackdrop(SignaInferreSK.bg)
	l:EnableMouse(true)
	l:SetToplevel(true)
	l:SetMovable(true)
	l:SetClampedToScreen(true)
	l:SetFrameStrata('DIALOG')
	l:SetScript('OnMouseDown', l.StartMoving)
	l:SetScript('OnMouseUp', l.StopMovingOrSizing)

	lBackground = l:CreateTexture(nil,"BACKGROUND")
	lBackground:SetTexture('Interface\\AddOns\\SignaInferreSK\\textures\\background256x256.tga')
	lBackground:SetPoint('CENTER', 0, 0)

	l.title = l:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	l.title:SetText("Generic List")
	l.title:SetPoint('TOP', 0, -15)

	l.close = CreateFrame('Button', nil, l, 'UIPanelCloseButton')
	l.close:SetPoint('TOPRIGHT', -5, -5)

	l.nTab = CreateFrame('Button', 'SISKListFrameTab1', l, "CharacterFrameTabButtonTemplate")
	l.nTab:SetPoint('CENTER', l, 'BOTTOMLEFT', 50, -10)
	l.nTab:SetID(1)
	l.nTab:SetText("Generic List")
	l.nTab:SetScript('OnClick', ClickNTab)

	l.tTab = CreateFrame('Button', 'SISKListFrameTab2', l, "CharacterFrameTabButtonTemplate")
	l.tTab:SetPoint("LEFT", l.nTab, "RIGHT", -15, 0);
	l.tTab:SetID(2)
	l.tTab:SetText("Token List")
	l.tTab:SetScript('OnClick', ClickTTab)

	l.iTab = CreateFrame('Button', 'SISKListFrameTab3', l, "CharacterFrameTabButtonTemplate")
	l.iTab:SetPoint("LEFT", l.tTab, "RIGHT", -15, 0);
	l.iTab:SetID(3)
	l.iTab:SetText("I/E List")
	l.iTab:SetScript('OnClick', ClickITab)

	l.enableCheck = CreateFrame('CheckButton', 'EnableButton', l, "OptionsCheckButtonTemplate")
	EnableButtonText:SetText("Use SISK for Loot")
	l.enableCheck:SetPoint('TOPLEFT', 15, -27)
	l.enableCheck:SetScript('OnClick', EnableClick)
	l.enableCheck:Hide();

	l.add = CreateFrame('Button', 'ListAddButton', l, "OptionsButtonTemplate")
	l.add:SetText("Add")
	l.add:SetPoint('TOPLEFT', 35, -28)
	l.add:SetScript('OnClick', AddClick)

	l.del = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.del:SetText("Delete")
	l.del:SetPoint('LEFT', l.add, 'RIGHT', 0, 0)
	l.del:SetScript('OnClick', DeleteClick)

	l.murder = CreateFrame('Button', 'ListMurderButton', l, "OptionsButtonTemplate")
	l.murder:SetText("Murder")
	l.murder:SetPoint('BOTTOMLEFT', 35, 38)
	l.murder:SetScript('OnClick', MurderClick)

	l.closeBid = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.closeBid:SetText("Close Bid/Roll")
	l.closeBid:SetPoint('BOTTOM', 0, 15)
	l.closeBid:SetWidth(180)
	l.closeBid:SetScript('OnClick', CloseBidClick)

	l.sync = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.sync:SetText("Sync")
	l.sync:SetPoint('LEFT', l.murder, 'RIGHT', 0, 0)
	l.sync:SetScript('OnClick', SyncClick)

	l.normalRadio = CreateFrame("CheckButton", "NormalRadioButton", l, "UIRadioButtonTemplate")
	NormalRadioButtonText:SetText("Generic List")
	l.normalRadio:SetPoint('BOTTOMLEFT', 35, 75)
	l.normalRadio:SetScript('OnClick', NormalRadioClick)
	l.normalRadio:SetChecked(1)
	l.normalRadio:Hide()

	l.tokenRadio = CreateFrame("CheckButton", "TokenRadioButton", l, "UIRadioButtonTemplate")
	TokenRadioButtonText:SetText("Token List")
	l.tokenRadio:SetPoint('LEFT', l.normalRadio, 'RIGHT', 75, 0)
	l.tokenRadio:SetScript('OnClick', TokenRadioClick)
	l.tokenRadio:Hide()

	l.export = CreateFrame('Button', 'ExportButton', l, "OptionsButtonTemplate")
	l.export:SetText("Export")
	l.export:SetPoint('BOTTOMLEFT', l.normalRadio, 0, -23)
	l.export:SetScript('OnClick', ExportClick)
	l.export:Hide();

	l.import = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.import:SetText("Import")
	l.import:SetPoint('LEFT', l.export, 'RIGHT', 0, 0)
	l.import:SetScript('OnClick', ImportClick)
	l.import:Hide();

	l.exportHistory = CreateFrame('Button', 'ExportHistoryButton', l, "OptionsButtonTemplate")
	l.exportHistory:SetText("Exp. History")
	l.exportHistory:SetPoint('BOTTOMLEFT', l.export, 0, -23)
	l.exportHistory:SetScript('OnClick', ExportHistoryClick)
	l.exportHistory:Hide();

	l.clearHistory = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.clearHistory:SetText("Clear History")
	l.clearHistory:SetPoint('LEFT', l.exportHistory, 'RIGHT', 0, 0)
	l.clearHistory:SetScript('OnClick', ClearHistoryClick)
	l.clearHistory:Hide();

	l.editScroll = CreateFrame("ScrollFrame", "IEEditScroll", l, "UIPanelScrollFrameTemplate")
	l.editScroll:SetPoint('TOPLEFT', 20, -55)
	l.editScroll:SetWidth(190); 
	l.editScroll:SetHeight(245);

	l.versionText = l:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l.versionText:SetPoint('BOTTOMLEFT', l.exportHistory, -15, -17)
	l.versionText:SetTextColor(1, 1, 1)
	l.versionText:SetText(format("Version: %s", GetAddOnMetadata("SignaInferreSK", "Version")))
	l.versionText:Hide()

	l.editArea = CreateFrame("EditBox", "IEEditScrollText", l.editScroll)
	l.editArea:SetAutoFocus(false)
	l.editArea:SetMultiLine(true)
	l.editArea:SetFontObject(ChatFontNormal)
	l.editArea:SetMaxLetters(99999)
	l.editArea:EnableMouse(true)
	l.editArea:SetScript("OnEscapePressed", l.editArea.ClearFocus)
	l.editArea:SetWidth(190)
	l.editArea:SetText("To Export Loot History: Hit Exp. History.\n\nTo Clear Loot History: Hit Clear History.\n\nTo Export List: Hit Export.\n\nTo Import List: Fill this box with the following format. Make sure names are capitalized correctly. Hit Import.\n\nFormat:\n1. Name Class\n2. Name Class\netc")

	l.editScroll:SetScrollChild(l.editArea)
	l.editScroll:Hide()

	l.list = CreateFrame('ScrollFrame', 'ScrollList', l, 'FauxScrollFrameTemplate')
	l.list:SetPoint('TOPLEFT', 10, -55)
	l.list:SetWidth(200); 
	l.list:SetHeight(265);
	l.list:SetScript('OnVerticalScroll', function(self, offset)
			FauxScrollFrame_OnVerticalScroll(self, offset, 16, ScrollList_Update);
			end)

	for i = 1, 17 do
		l["entry" .. i] = CreateFrame('Button', 'entry' .. i, l)
		if i == 1 then
			l["entry" .. i]:SetPoint('TOPLEFT', l.list, 'TOPLEFT', 8, 0)
		else
			l["entry" .. i]:SetPoint('TOPLEFT', l["entry" .. i - 1], 'BOTTOMLEFT')
		end
		l["entry" .. i].text = l["entry" .. i]:CreateFontString('entry' .. i .. '_Text', 'BORDER','GameFontHighlightLeft')
		l["entry" .. i].text:SetText('entry' .. i)
		l["entry" .. i].text:SetPoint('LEFT')
		l["entry" .. i]:SetWidth(200)
		l["entry" .. i]:SetHeight(16)
		l["entry" .. i]:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
		l["entry" .. i]:EnableMouse(true)
		l["entry" .. i]:SetScript('OnClick', EntryClick)
		l["entry" .. i]:SetID(i)
	end

	l.down = CreateFrame('Button', 'downButton', l, 'UIPanelScrollDownButtonTemplate')
	l.down:SetPoint('RIGHT', l.entry1, 'RIGHT')
	l.down:SetFrameStrata('FULLSCREEN')
	l.down:SetScript('OnClick', DownClick)
	l.down:Hide()

	l.up = CreateFrame('Button', 'upButton', l, 'UIPanelScrollUpButtonTemplate')
	l.up:SetPoint('RIGHT', l.down, 'LEFT')
	l.up:SetFrameStrata('FULLSCREEN')
	l.up:SetScript('OnClick', UpClick)
	l.up:Hide()

	local c = CreateFrame('Frame', 'SISKConfirmFrame', UIParent, BackdropTemplateMixin and "BackdropTemplate");
	c:Hide();

	c:SetWidth(350); 
	c:SetHeight(80);
	c:SetPoint("CENTER");
	c:SetBackdrop(SignaInferreSK.bg)
	c:EnableMouse(true)
	c:SetToplevel(true)
	c:SetMovable(true)
	c:SetClampedToScreen(true)
	c:SetFrameStrata('DIALOG')
	c:SetScript('OnMouseDown', c.StartMoving)
	c:SetScript('OnMouseUp', c.StopMovingOrSizing)

	c.title = c:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	c.title:SetText("This will delete and replace the existing list.\nAre you sure?")
	c.title:SetPoint('TOP', 0, -15)

	c.accept = CreateFrame('Button', 'AcceptButton', c, "OptionsButtonTemplate")
	c.accept:SetText("Accept")
	c.accept:SetPoint('BOTTOMLEFT', 35, 15)
	c.accept:SetScript('OnClick', AcceptClick)

	c.decline = CreateFrame('Button', nil, c, "OptionsButtonTemplate")
	c.decline:SetText("Decline")
	c.decline:SetPoint('BOTTOMRIGHT', -35, 15)
	c.decline:SetScript('OnClick', DeclineClick)

	local d = CreateFrame('Frame', 'SISKConfirmClearHistoryFrame', UIParent, BackdropTemplateMixin and "BackdropTemplate");
	d:Hide();

	d:SetWidth(350); 
	d:SetHeight(80);
	d:SetPoint("CENTER");
	d:SetBackdrop(SignaInferreSK.bg)
	d:EnableMouse(true)
	d:SetToplevel(true)
	d:SetMovable(true)
	d:SetClampedToScreen(true)
	d:SetFrameStrata('DIALOG')
	d:SetScript('OnMouseDown', d.StartMoving)
	d:SetScript('OnMouseUp', d.StopMovingOrSizing)

	d.title = d:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	d.title:SetText("This will delete the existing loot history.\nAre you sure?")
	d.title:SetPoint('TOP', 0, -15)

	d.accept = CreateFrame('Button', 'AcceptButton', d, "OptionsButtonTemplate")
	d.accept:SetText("Accept")
	d.accept:SetPoint('BOTTOMLEFT', 35, 15)
	d.accept:SetScript('OnClick', AcceptClearHistoryClick)

	d.decline = CreateFrame('Button', nil, d, "OptionsButtonTemplate")
	d.decline:SetText("Decline")
	d.decline:SetPoint('BOTTOMRIGHT', -35, 15)
	d.decline:SetScript('OnClick', DeclineClearHistoryClick)

	local e = CreateFrame('Frame', 'SISKConfirmGiveLootFrame', UIParent, BackdropTemplateMixin and "BackdropTemplate");
	e:Hide();

	e:SetWidth(350); 
	e:SetHeight(80);
	e:SetPoint("CENTER");
	e:SetBackdrop(SignaInferreSK.bg)
	e:EnableMouse(true)
	e:SetToplevel(true)
	e:SetMovable(true)
	e:SetClampedToScreen(true)
	e:SetFrameStrata('DIALOG')
	e:SetScript('OnMouseDown', e.StartMoving)
	e:SetScript('OnMouseUp', e.StopMovingOrSizing)

	e.title = e:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	e.title:SetPoint('TOP', 0, -15)

	e.accept = CreateFrame('Button', 'AcceptButton', e, "OptionsButtonTemplate")
	e.accept:SetText("Accept")
	e.accept:SetPoint('BOTTOMLEFT', 35, 15)
	e.accept:SetScript('OnClick', AcceptGiveLootClick)

	e.decline = CreateFrame('Button', nil, e, "OptionsButtonTemplate")
	e.decline:SetText("Decline")
	e.decline:SetPoint('BOTTOMRIGHT', -35, 15)
	e.decline:SetScript('OnClick', DeclineGiveLootClick)

	SISKListFrame.add:Disable();
	SISKListFrame.del:Disable();
	SISKListFrame.murder:Disable();
	SISKListFrame.up:Disable();
	SISKListFrame.down:Disable();
	SISKListFrame.closeBid:Disable();
	SISKListFrame.enableCheck:Disable();
	SISKListFrame.import:Disable();

	SISKListFrame.selectedEntry = 0;

	PanelTemplates_SetNumTabs(l, 3);
	PanelTemplates_TabResize(l.nTab, 30)
	PanelTemplates_TabResize(l.tTab, 30)
	PanelTemplates_TabResize(l.iTab, 30)
	PanelTemplates_SetTab(l, 1);
end

function SignaInferreSK:OnDisable()
end

function SignaInferreSK:IsMaster()
	local ret
	local _, master, _ = GetLootMethod();

	if (master ~= nil) and (master == 0) and (SignaInferreSK:IsAtLeastMasterLooter()) then
		ret = true;
	else
		ret = false;
	end

	return ret;
end

function SignaInferreSK:GROUP_ROSTER_UPDATE()
	if (SignaInferreSK:IsMaster()) then
		SISKListFrame.add:Enable();
		SISKListFrame.del:Enable();
		SISKListFrame.murder:Enable();
		SISKListFrame.up:Enable();
		SISKListFrame.down:Enable();
		SISKListFrame.enableCheck:Enable();
		SISKListFrame.import:Enable();
		Master = true;
	else
		SISKListFrame.add:Disable();
		SISKListFrame.del:Disable();
		SISKListFrame.murder:Disable();
		SISKListFrame.up:Disable();
		SISKListFrame.down:Disable();
		SISKListFrame.closeBid:Disable();
		SISKListFrame.enableCheck:Disable();
		SISKListFrame.import:Disable();
		AddonEnabled = false;
		Master = false;
	end
	ScrollList_Update();
end

function SignaInferreSK:CreateTimeStamp(oldstamp)
	local _, hour, minute = GameTime_GetGameTime(false);
	local CalendarDate = C_DateAndTime.GetTodaysDate()
	local month, day, year = CalendarDate.month, CalendarDate.day, CalendarDate.year
	if (hour < 10) then
		hour = "0"..hour;
	end
	if (minute < 10) then
		minute = "0"..minute;
	end
	if (day < 10) then
		day = "0"..day;
	end
	if (month < 10) then
		month = "0"..month;
	end

	local newstr = year..month..day..hour..minute;

	local oldstr = strsub(tostring(oldstamp), 1, -3);
	local oldcount = strsub(tostring(oldstamp), -2)

	local newstamp
	if(newstr == oldstr) then
		newstamp = tonumber(oldstr..oldcount);
		newstamp = newstamp + 1;
	else
		newstamp = tonumber(newstr.."00");
	end
	
	return newstamp;
end

function SignaInferreSK:OpenList(input)
	ScrollList_Update();
	SISKListFrame:Show();
end

function SignaInferreSK:SetOpenItem(item)
	local i = Item:CreateFromItemLink(item)
	i:ContinueOnItemLoad(function()
		local itemIcon = i:GetItemIcon()
		local r, g, b = i:GetItemQualityColor()

		SISKBidFrame.link:AddMessage(item)

		SetItemButtonTexture(SISKBidFrame.item, itemIcon)
		SetItemButtonNormalTextureVertexColor(SISKBidFrame.item, r, g, b)
	end)
end

function SignaInferreSK:FindInTable(person, list)
	local ret = 0;
	if (list == "nList") then
		for i=1, SignaInferreSK.db.char.nLength, 1 do
			if (SignaInferreSK.db.char.nList[i].name == person) then
				ret = i;
			end
		end
	else
		for i=1, SignaInferreSK.db.char.tLength, 1 do
			if (SignaInferreSK.db.char.tList[i].name == person) then
				ret = i;
			end
		end
	end
	return ret;
end

function SignaInferreSK:OpenBidding(prefix, message, distribution, sender)
	BidType = "bid";
	ItemLink = message;
	SignaInferreSK:SetOpenItem(ItemLink);
	SISKBidFrame.roll:Disable();
	SISKBidFrame:Show();
end

function SignaInferreSK:OpenRolling(prefix, message, distribution, sender)
	BidType = "roll";
	ItemLink = message;
	SignaInferreSK:SetOpenItem(ItemLink);
	SISKBidFrame.bid:Disable();
	SISKBidFrame:Show();
end

function SignaInferreSK:CloseBid(prefix, message, distribution, sender)
	SISKBidFrame:Hide();
	SISKBidFrame.roll:Enable();
	SISKBidFrame.pass:Enable();
	SISKBidFrame.bid:Enable();
	SISKBidFrame.retract:Disable();
	SISKBidFrame.text:SetText("<No High Bidder>");
	SISKBidFrame.text:SetTextColor(1, 1, 1);

	for i=1, SignaInferreSK.db.char.nLength, 1 do
		SignaInferreSK.db.char.nList[i].bid = "";
	end

	for i=1, SignaInferreSK.db.char.tLength, 1 do
		SignaInferreSK.db.char.tList[i].bid = "";
	end

	ScrollList_Update();
end

function SignaInferreSK:WhichList()
	local itemName, _, _, _, _, iType, iSubType = GetItemInfo(ItemLink)
	if (iType == AUCTION_CATEGORY_MISCELLANEOUS and iSubType == BAG_FILTER_JUNK and SignaInferreSK:CheckTokenName(itemName)) then
		return "tList";
	else
		return "nList";
	end
end

function SignaInferreSK:CheckTokenName(itemName)
	for value in pairs(TokenNames) do
		if value == itemName then
			return true
		end
	end

	return false
end

function SignaInferreSK:FindHighRoller()
	local roll = 0; 
	local name = "";
	local found = false;
	for i=1, RollCount, 1 do 
		if (RollList[i].roll > roll) and (RollList[i].retracted == false) then
			roll = RollList[i].roll;
			name = RollList[i].name;
			found = true;
		end
	end
	if (found) then
		return name, roll;
	else
		return "", 0;
	end
end

function SignaInferreSK:RemoveRoller(name) 
	for i=1, RollCount, 1 do 
		if (RollList[i].name == name) then
			RollList[i].retracted = true;
			break
		end
	end

	return true
end

function SignaInferreSK:RemoveBidder(name)
	local list = SignaInferreSK:WhichList();
	local rank = SignaInferreSK:FindInTable(name, list);
	local bidrank = 0;
	for index,value in ipairs(BidList) do 
		if (value == rank) then
			bidrank = index;
			break
		end
	end

	table.remove(BidList, bidrank);
	table.sort(BidList);
end

function SignaInferreSK:AddRoller(name)
	local found = false;
	local roll;
	for i=1, RollCount, 1 do 
		if (RollList[i].name == name) and (RollList[i].retracted) then
			RollList[i].retracted = false;
			roll = RollList[i].roll;
			found = true;
			break
		end
	end

	if(found == false) then
		roll = math.random(1, 100);
		RollCount = RollCount+1;
		RollList[RollCount] = {name = name, roll = roll, retracted = false}
	end
	return roll;
end

function SignaInferreSK:AddBidToList(bid, rank, list)
	if(list == "nList") then
		SignaInferreSK.db.char.nList[rank].bid = bid;
	elseif(list == "tList") then
		SignaInferreSK.db.char.tList[rank].bid = bid;
	end
	ScrollList_Update();
end

function SignaInferreSK:UpdateWinner()
	if (HighName ~= "") then
		local _, englishClass = UnitClass(HighName)
		SignaInferreSK:SendCommMessage("SISKNewHigh", SignaInferreSK:Serialize("Bid: "..HighRank..". "..HighName, englishClass), "RAID");
	elseif (HighRoller ~= "") then
		local _, englishClass = UnitClass(HighRoller)
		SignaInferreSK:SendCommMessage("SISKNewHigh", SignaInferreSK:Serialize("Roll: "..HighRoller..": "..HighRoll, englishClass), "RAID");
	else
		SignaInferreSK:SendCommMessage("SISKNewHigh", SignaInferreSK:Serialize("<No High Bidder>", "PRIEST"), "RAID");
	end
end

function SignaInferreSK:ReceiveBid(prefix, message, distribution, sender)
	if (BidNotOpen == false) then
		local success, bidType, bidder = SignaInferreSK:Deserialize(message);
		local list = SignaInferreSK:WhichList();
		local rank = SignaInferreSK:FindInTable(bidder, list);

		if(rank ~= 0) then
			if (Master) then
				BidsReceived = BidsReceived + 1;

				if (bidType == "bid") then
					SendChatMessage(bidder.." bids "..ItemLink , "RAID");
					table.insert(BidList, rank);
					table.sort(BidList);
					if (rank < HighRank) then
						HighRank = rank;
						HighName = bidder;
					end
				elseif (bidType == "roll") then
					local roll = SignaInferreSK:AddRoller(bidder);
					SendChatMessage(bidder.." rolls "..roll.." (1-100) "..ItemLink , "RAID");
					HighRoller, HighRoll = SignaInferreSK:FindHighRoller();
				end

				SignaInferreSK:UpdateWinner();

				if (BidsReceived == GetNumGroupMembers()) then
					SendChatMessage("All bids received!", "RAID");
				end
			end

			if (bidType == "bid") then
				SignaInferreSK:AddBidToList("Bid", rank, list);
			elseif (bidType == "roll") then
				SignaInferreSK:AddBidToList("Roll", rank, list);
			elseif (bidType == "pass") then
				SignaInferreSK:AddBidToList("Pass", rank, list);
			end
		else
			if (Master) then
				SignaInferreSK:Print(string.format("|cffff0000Warning:|r %s tried to bid '%s' while not on %s list.", bidder, bidType, list == "nList" and "generic" or "token"))
			end
		end
	end
end

function SignaInferreSK:ReceiveSyncReq(prefix, message, distribution, sender)
	if (message == "master") and (SignaInferreSK:IsAtLeastMasterLooter()) and (Master == false) then
		SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	elseif (message == "not master") and (Master) then
		SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "GUILD");
	end
end

function SignaInferreSK:ReceiveBroadcast(prefix, message, distribution, sender)
	local success, nstamp, nlength, nlist, tstamp, tlength, tlist = SignaInferreSK:Deserialize(message);

	if (nstamp ~= nil and tonumber(nstamp) ~= nil) then
		if (SignaInferreSK.db.char.nStamp == nil or tonumber(nstamp) > SignaInferreSK.db.char.nStamp) then
			SignaInferreSK.db.char.nStamp = tonumber(nstamp);
			SignaInferreSK.db.char.nLength = tonumber(nlength);
			SignaInferreSK.db.char.nList = nlist;
		end
	end

	if (tstamp ~= nil and tonumber(tstamp) ~= nil) then
		if (SignaInferreSK.db.char.tStamp == nil or tonumber(tstamp) > SignaInferreSK.db.char.tStamp) then
			SignaInferreSK.db.char.tStamp = tonumber(tstamp);
			SignaInferreSK.db.char.tLength = tonumber(tlength);
			SignaInferreSK.db.char.tList = tlist;
		end
	end

	if (Master) then
		SignaInferreSK:SendCommMessage("SISKBroadcast", SignaInferreSK:Serialize(SignaInferreSK.db.char.nStamp, SignaInferreSK.db.char.nLength, SignaInferreSK.db.char.nList, SignaInferreSK.db.char.tStamp, SignaInferreSK.db.char.tLength, SignaInferreSK.db.char.tList), "RAID");
	end

	ScrollList_Update();
end

function SignaInferreSK:ReceiveList(prefix, message, distribution, sender)
	local success, nstamp, nlength, nlist, tstamp, tlength, tlist = SignaInferreSK:Deserialize(message);

	if (nstamp ~= nil and tonumber(nstamp) ~= nil) then
		if (SignaInferreSK.db.char.nStamp == nil or tonumber(nstamp) > SignaInferreSK.db.char.nStamp) then
			SignaInferreSK.db.char.nStamp = tonumber(nstamp);
			SignaInferreSK.db.char.nLength = tonumber(nlength);
			SignaInferreSK.db.char.nList = nlist;
		end
	end

	if (tstamp ~= nil and tonumber(tstamp) ~= nil) then
		if (SignaInferreSK.db.char.tStamp == nil or tonumber(tstamp) > SignaInferreSK.db.char.tStamp) then
			SignaInferreSK.db.char.tStamp = tonumber(tstamp);
			SignaInferreSK.db.char.tLength = tonumber(tlength);
			SignaInferreSK.db.char.tList = tlist;
		end
	end

	ScrollList_Update();
end

function SignaInferreSK:RetractBid(prefix, message, distribution, sender)
	if (BidNotOpen == false) then
		local success, bidType, bidder = SignaInferreSK:Deserialize(message);
		local list = SignaInferreSK:WhichList();
		local rank = SignaInferreSK:FindInTable(bidder, list);

		if (rank ~= 0) then
			if (Master) then
				BidsReceived = BidsReceived - 1;

				if(bidType == "bid") then
					SignaInferreSK:RemoveBidder(bidder);
					SendChatMessage(bidder.." has retracted their bid.", "RAID");

					if(BidList[1] ~= nil) then
						HighRank = BidList[1];
						if(list == "nList") then
							HighName = SignaInferreSK.db.char.nList[HighRank].name;
						else
							HighName = SignaInferreSK.db.char.tList[HighRank].name;
						end
					else
						HighRank = 5000;
						HighName = "";
					end
				elseif (bidType == "roll") then
					SignaInferreSK:RemoveRoller(bidder);
					HighRoller, HighRoll = SignaInferreSK:FindHighRoller();
					SendChatMessage(bidder.." has retracted their roll.", "RAID");
				elseif (bidType == "pass") then
					SendChatMessage(bidder.." has retracted their pass.", "RAID");
				end
				SignaInferreSK:UpdateWinner();
			end

			local rank = SignaInferreSK:FindInTable(bidder, list);

			if(list == "nList") then
				SignaInferreSK.db.char.nList[rank].bid = "";
			elseif(list == "tList") then
				SignaInferreSK.db.char.tList[rank].bid = "";
			end
			ScrollList_Update();
		end
	end
end

function SignaInferreSK:HighBidder(prefix, message, distribution, sender)
	if (SISKBidFrame:IsVisible()) then
		local success, text, class = SignaInferreSK:Deserialize(message);
		local color = RAID_CLASS_COLORS[class];
		SISKBidFrame.text:SetText(text);
		SISKBidFrame.text:SetTextColor(color.r, color.g, color.b);
	end
end

function SignaInferreSK:SISK_HandleModifiedItemClick(item)
	if (Master and AddonEnabled) then
		if (BidNotOpen) then
			if (IsAltKeyDown() and 
				not IsShiftKeyDown() and 
					not IsControlKeyDown()) then
				ItemLink = item;
				SendChatMessage("Bid open for "..ItemLink.."! - 20s", "RAID_WARNING");
				BidTicker = C_Timer.NewTicker(1, function(self) if Timer<0 then BidTicker:Cancel() elseif Timer==0 then SendChatMessage(format("%ds - Bid closed!", Timer), "RAID_WARNING") elseif Timer==15 or Timer==10 or Timer==5 then SendChatMessage(format("%ds", Timer), "RAID_WARNING") end Timer=Timer-1 end)
				SignaInferreSK:SendCommMessage("SISKOpenBid", ItemLink, "RAID");
				BidNotOpen = false;
				SISKListFrame.closeBid:Enable();
			elseif (IsShiftKeyDown() and 
				not IsAltKeyDown() and 
					not IsControlKeyDown()) then
				ItemLink = item;
				SendChatMessage("Roll open for "..ItemLink.."! - 20s", "RAID_WARNING");
				RollTicker = C_Timer.NewTicker(1, function(self) if Timer<0 then RollTicker:Cancel() elseif Timer==0 then SendChatMessage(format("%ds - Roll closed!", Timer), "RAID_WARNING") elseif Timer==15 or Timer==10 or Timer==5 then SendChatMessage(format("%ds", Timer), "RAID_WARNING") end Timer=Timer-1 end)
				SignaInferreSK:SendCommMessage("SISKOpenRoll", ItemLink, "RAID");
				BidNotOpen = false;
				SISKListFrame.closeBid:Enable();
			end
		end
	end
end

function SignaInferreSK:IsAtLeastMasterLooter()
	if not IsInGuild() then
		return false
	end

	return C_GuildInfo.GetGuildRankOrder(UnitGUID("player")) < 6;
end

function SignaInferreSK:SaveHistory(lootReciever)
	if (SignaInferreSK.db.char.hLength == nil) then
		SignaInferreSK.db.char.hLength = 0;
	end
	if (SignaInferreSK.db.char.hList == nil) then
		SignaInferreSK.db.char.hList = {};
	end

	local _, hour, minute = GameTime_GetGameTime(false);
	local CalendarDate = C_DateAndTime.GetTodaysDate()
	local month, day, year = CalendarDate.month, CalendarDate.day, CalendarDate.year
	if (hour < 10) then
		hour = "0"..hour;
	end
	if (minute < 10) then
		minute = "0"..minute;
	end
	if (day < 10) then
		day = "0"..day;
	end
	if (month < 10) then
		month = "0"..month;
	end

	local timestampStr = day.."/"..month.."/"..year.." "..hour..":"..minute;
	local itemName = GetItemInfo(ItemLink);
	local listType = "-";

	if (BidType == "bid" ) then
		if (SignaInferreSK:WhichList() == "nList") then
			listType = "Generic";
		else
			listType = "Token";
		end
	end

	SignaInferreSK.db.char.hLength = SignaInferreSK.db.char.hLength + 1;
	SignaInferreSK.db.char.hList[SignaInferreSK.db.char.hLength] = {name = lootReciever, item = itemName, bidType = BidType, list = listType, timestamp = timestampStr};
end
